/*
 * Copyright 2010-2015 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * Additions Copyright 2016 Espressif Systems (Shanghai) PTE LTD
 *
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 *
 *  http://aws.amazon.com/apache2.0
 *
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/**
 * @file aws_iot_certifcates.c
 * @brief File to store the AWS certificates in the form of arrays
 */

#ifdef __cplusplus
extern "C" {
#endif

const char aws_root_ca_pem[] = {"-----BEGIN CERTIFICATE-----\n\
MIIDQTCCAimgAwIBAgITBmyfz5m/jAo54vB4ikPmljZbyjANBgkqhkiG9w0BAQsF\n\
ADA5MQswCQYDVQQGEwJVUzEPMA0GA1UEChMGQW1hem9uMRkwFwYDVQQDExBBbWF6\n\
b24gUm9vdCBDQSAxMB4XDTE1MDUyNjAwMDAwMFoXDTM4MDExNzAwMDAwMFowOTEL\n\
MAkGA1UEBhMCVVMxDzANBgNVBAoTBkFtYXpvbjEZMBcGA1UEAxMQQW1hem9uIFJv\n\
b3QgQ0EgMTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBALJ4gHHKeNXj\n\
ca9HgFB0fW7Y14h29Jlo91ghYPl0hAEvrAIthtOgQ3pOsqTQNroBvo3bSMgHFzZM\n\
9O6II8c+6zf1tRn4SWiw3te5djgdYZ6k/oI2peVKVuRF4fn9tBb6dNqcmzU5L/qw\n\
IFAGbHrQgLKm+a/sRxmPUDgH3KKHOVj4utWp+UhnMJbulHheb4mjUcAwhmahRWa6\n\
VOujw5H5SNz/0egwLX0tdHA114gk957EWW67c4cX8jJGKLhD+rcdqsq08p8kDi1L\n\
93FcXmn/6pUCyziKrlA4b9v7LWIbxcceVOF34GfID5yHI9Y/QCB/IIDEgEw+OyQm\n\
jgSubJrIqg0CAwEAAaNCMEAwDwYDVR0TAQH/BAUwAwEB/zAOBgNVHQ8BAf8EBAMC\n\
AYYwHQYDVR0OBBYEFIQYzIU07LwMlJQuCFmcx7IQTgoIMA0GCSqGSIb3DQEBCwUA\n\
A4IBAQCY8jdaQZChGsV2USggNiMOruYou6r4lK5IpDB/G/wkjUu0yKGX9rbxenDI\n\
U5PMCCjjmCXPI6T53iHTfIUJrU6adTrCC2qJeHZERxhlbI1Bjjt/msv0tadQ1wUs\n\
N+gDS63pYaACbvXy8MWy7Vu33PqUXHeeE6V/Uq2V8viTO96LXFvKWlJbYK8U90vv\n\
o/ufQJVtMVT8QtPHRh8jrdkPSHCa2XV4cdFyQzR1bldZwgJcJmApzyMZFo6IQ6XU\n\
5MsI+yMRQ+hDKXJioaldXgjUkK642M4UwtBV8ob2xJNDd2ZhwLnoQdeXeGADbkpy\n\
rqXRfboQnoZsG4q5WTP468SQvvG5\n\
-----END CERTIFICATE-----\n"};

const char certificate_pem_crt[] = {"-----BEGIN CERTIFICATE-----\n\
MIIDWjCCAkKgAwIBAgIVAKVSQwsDXKAOI4WqiydKb8JPqQT5MA0GCSqGSIb3DQEB\n\
CwUAME0xSzBJBgNVBAsMQkFtYXpvbiBXZWIgU2VydmljZXMgTz1BbWF6b24uY29t\n\
IEluYy4gTD1TZWF0dGxlIFNUPVdhc2hpbmd0b24gQz1VUzAeFw0yMTA1MjUwNzA2\n\
MzRaFw00OTEyMzEyMzU5NTlaMB4xHDAaBgNVBAMME0FXUyBJb1QgQ2VydGlmaWNh\n\
dGUwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQC9yAiM6Zp87Qi7smGH\n\
jtRK6cByoJEVfHgTzX+k09812pYkc+51kwBs87KZax+T9n/NgZhkwfII1OElM89h\n\
AInvecbQSYBJcvSzckFuy9HfnTVcVJpo5L2/nAGEZGc99OFAD/g59KplvA+MUTem\n\
RXD594LSA5U5gGRQqIiZwoCnRLBSwKXnf4TpAdXQJCzlYP6RLensx4XsPFwqdhMx\n\
pfD3LAij4oR9ejOYGqesYh8fj15YJM53Bb3JSZFFaqX4GDRJZa+rIsMP0XBcT1/H\n\
URZ1wr97SM9E/Z0h7AMR04IGeQsLdFb9HWcNVWtY2BWZPqp3/npanWfSU40U5ACA\n\
6q49AgMBAAGjYDBeMB8GA1UdIwQYMBaAFJkCx0YZJaqUilVEJDfKiEJjme8vMB0G\n\
A1UdDgQWBBT/uAaJtAKRgAEg5wyQjW7FAAqPgzAMBgNVHRMBAf8EAjAAMA4GA1Ud\n\
DwEB/wQEAwIHgDANBgkqhkiG9w0BAQsFAAOCAQEAnvOLsfKSlezRJqqlR4WId9D9\n\
GnnXrRFzGtr/gT1wX2Tb42jJ1fn2g5L4yizs9OVJ1rJ0WIPYwlZf1ohuympLR5+R\n\
Tsf7F1SsK71YNGwefrwXQG0Iy2LRu50WmcBqaGmLix0CHStKHm5uCX9Ipu839bn5\n\
4SUv/JUaTeVG1X4cgOjQDrlx4XeOmwY+EvCHXsqrifGdZOYPv9RZCDaUNtZHXKBC\n\
pkQoALNDN29ACLEAcR2BMZn3/H2R0JGZtJ1cyQUW+HtYC6ysL9FUql5KeW7D4MqM\n\
IGM+vWi4v8HMnv3kZivqzfduNlwe//5q6QLo/6FlG5lwYvBh0avZJ6TbVfZXog==\n\
-----END CERTIFICATE-----\n"};

const char private_pem_key[] = {"-----BEGIN RSA PRIVATE KEY-----\n\
MIIEowIBAAKCAQEAvcgIjOmafO0Iu7Jhh47USunAcqCRFXx4E81/pNPfNdqWJHPu\n\
dZMAbPOymWsfk/Z/zYGYZMHyCNThJTPPYQCJ73nG0EmASXL0s3JBbsvR3501XFSa\n\
aOS9v5wBhGRnPfThQA/4OfSqZbwPjFE3pkVw+feC0gOVOYBkUKiImcKAp0SwUsCl\n\
53+E6QHV0CQs5WD+kS3p7MeF7DxcKnYTMaXw9ywIo+KEfXozmBqnrGIfH49eWCTO\n\
dwW9yUmRRWql+Bg0SWWvqyLDD9FwXE9fx1EWdcK/e0jPRP2dIewDEdOCBnkLC3RW\n\
/R1nDVVrWNgVmT6qd/56Wp1n0lONFOQAgOquPQIDAQABAoIBACH0voLn8TpU9vEO\n\
c6Dbj2Rv+n0H+a2MfbedVy9YsWFjYOXY0Fu9F6Bm4hfNMPM6cZeFjozIntOxsy8C\n\
3CIRBJ0Sft4ZqJh7twi8crSuRzjpWfjRMmd+Ne0orqTPiiFtxTe/I7zK6AoX4fhL\n\
N9fKKPKwtHl7JqIJNOmxne9U+8vxkPhdTCqdNs9ayhM2lm5qpP/eDFfIef6CBUf2\n\
MBvJNII/pxDAuZB6q7jH2pUl337nM1x17RnqXdZbwrE3yYssAJIF8gMXaTTSHigp\n\
RJcuddqkOg//TrRSAGRcLPYVB/u/xXgQOFE/l8tIh/NXW+w7N/5kPNuql61mkThS\n\
6+71JQkCgYEA9giMzh4Y3dhNBhVgL+Z8IY8Oj8Ry4VPL2oVLai8AtryhLTi8HoJt\n\
6A6Ek7XcgCP7z7xlgdB230j9tJknXQR5IjFXB0AoTu6bGcCuN+sg8YPQYkqgVgss\n\
pyuFAvZBcJclbw47/I0wvijKNBssHuB268t4lJTrQjY6rIJ7cmNo46sCgYEAxXgh\n\
fhp/d1QWiwvr/e8x/G9YlzP4j6i5x1UvuUD364PZpCzYtrtsyZAOxzlcbqFO9Khh\n\
sbEXt2gHMyY0d2OKjextDtSGpq/rejs7k9/KCT0AtshyW+RZ39xdzV1qYFyZqbQA\n\
wtk+Po14rOrQLU9wSBeJoBZPnMScmNAlTrfgzbcCgYEAnGdnC4j6idz9agagtRKy\n\
iqrkuORLm46nouzlukTTEVfsplDQ1hxYPhMsmLId0KAPbkn3xYR+bQd7sRlDetBj\n\
KSdwib1xYmww0Tg6CHZC5QXErRd/wfMsmcECt5VQmICdXXIRFEW1XM2VbXZwn9hW\n\
ASPCLcJVpCvRNOVmEJu9jC0CgYAdyyJChHz25BkCoanZhl1kWOhk59J42lwtVwz8\n\
RnEhd6M+wgVwjJa9Up7oMB9iEbR39W/H/5A0e92aOglwefRNtX4+3pHyVFiS+Jzk\n\
kr9I5YtWCKg4dRuaSwVcFtwV7eLBWAdFXsGlbnLmpAcEzxeByQtavAMHBCMca0s1\n\
tUiVwQKBgD4/4icR+q388k9y/OoJXuVG/jxcN+ueGereAGX5UaEfs839C7IcvZ/q\n\
xqgszppEXKCr6Hkpa8BkjqOnHFQkw6DSHY7qFhlRtBWMEmiX/zyzHo6T0t7WOJf9\n\
lK7zyS2S41ilukEcwm9feXsvXsQ7TZjpf5v6iQLHLpyhpZ3wXXdT\n\
-----END RSA PRIVATE KEY-----\n"};


#ifdef __cplusplus
}
#endif
