/***************************************************************************************************
                                    ExploreEmbedded Copyright Notice    
****************************************************************************************************
 * File:   AWS_IOT.cpp
 * Version: 1.0
 * Author: ExploreEmbedded
 * Website: http://www.exploreembedded.com/wiki
 * Description: ESP32  Arduino library for AWS IOT.
 
This code has been developed and tested on ExploreEmbedded boards.  
We strongly believe that the library works on any of development boards for respective controllers. 
Check this link http://www.exploreembedded.com/wiki for awesome tutorials on 8051,PIC,AVR,ARM,Robotics,RTOS,IOT.
ExploreEmbedded invests substantial time and effort developing open source HW and SW tools, to support consider buying the ExploreEmbedded boards.
 
The ExploreEmbedded libraries and examples are licensed under the terms of the new-bsd license(two-clause bsd license).
See also: http://www.opensource.org/licenses/bsd-license.php

EXPLOREEMBEDDED DISCLAIMS ANY KIND OF HARDWARE FAILURE RESULTING OUT OF USAGE OF LIBRARIES, DIRECTLY OR
INDIRECTLY. FILES MAY BE SUBJECT TO CHANGE WITHOUT PRIOR NOTICE. THE REVISION HISTORY CONTAINS THE INFORMATION 
RELATED TO UPDATES.
 

Permission to use, copy, modify, and distribute this software and its documentation for any purpose
and without fee is hereby granted, provided that this copyright notices appear in all copies 
and that both those copyright notices and this permission notice appear in supporting documentation.
**************************************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdio.h>
#include <Arduino.h>
#include <system_parameter.h>
#include <parameter_config.h>

extern system_parameter eg118_system_parameter_at_module;


#include "adc.h"


int steady_average_adcvalue = 0;
//#define ADCMAXGAPVALUE 10
#define ADCMAXCOUNT 15
int adcarray[ADCMAXCOUNT];
int adc_index = 0;
//#define  BIG_CURRENT 18000
//#define  SMALL_CURRENT 6000


static float drv_get_ADCchangetocurrent(uint16_t adcvalue) 
{
   float line_k = 13;
   float adc_modle_line_d = 2087;
   unsigned int gv_big_current_adc = 1121;
   int gv_small_current_adc = 284;
   float big_ai = 18000;
   float small_ai = 6000;

  
  
  float eg118ai_status;
  //很多设备没有做adc校准或者混乱了 
  //这里固定一组值，也不会偏离太远，大概的精度也是够的，如果追求更高的精度，分段计算斜率与截距在考虑，吓死你用简洁算法
  //gv_big_current_adc = eg118_system_parameter_at_module.get_bigcurrent_adc();
  gv_big_current_adc=1150;
  if (gv_big_current_adc==0)
  {
        gv_big_current_adc = 1150;//出错默认值
  }
    if (gv_big_current_adc==-1)
  {
       gv_big_current_adc = 1150;//出错默认值
  }
  if ( (gv_big_current_adc < 1000) ||(gv_big_current_adc > 1200) )
  {
    gv_big_current_adc = 1121;//出错默认值
  }

  //很多设备没有做adc校准或者混乱了 
  //这里固定一组值，也不会偏离太远，大概的精度也是够的，如果追求更高的精度，分段计算斜率与截距在考虑，吓死你用简洁算法
  //gv_small_current_adc = eg118_system_parameter_at_module.get_smallcurrent_adc();
  gv_small_current_adc=284;
  //Serial.printf("[loop_line 892]<get_ADCchangetocurrent>small_current_adc->%d [0x%x]  \n", gv_small_current_adc, gv_small_current_adc);
  
  if (gv_small_current_adc==0)
  {
       gv_small_current_adc = 284;  //出错默认值
  }
    if (gv_small_current_adc==-1)
  {
       gv_small_current_adc = 284;  //出错默认值
  }
  if ( (gv_big_current_adc < 200) ||(gv_small_current_adc > 310) )
  {
    gv_small_current_adc = 284;  //出错默认值
  }

  if ((gv_big_current_adc - gv_small_current_adc) != 0) {
    line_k = ((big_ai - small_ai)) / (gv_big_current_adc - gv_small_current_adc);
  }
  adc_modle_line_d = small_ai - gv_small_current_adc * line_k;

  eg118ai_status = line_k * adcvalue + adc_modle_line_d;
  // Serial.printf("[drv_get_ADCchangetocurrent line 98]->gv_big_current_adc=%d\n",gv_big_current_adc);
  // Serial.printf("[drv_get_ADCchangetocurrent line 99]->gv_big_current_adc=%d\n",gv_small_current_adc);
  // Serial.printf("[drv_get_ADCchangetocurrent line 100]->eg118ai_status= %2.3f \n",eg118ai_status/1000);
  return eg118ai_status /1000;
}


static int drv_get_average_adcvalue(void) 
{
  return steady_average_adcvalue;
}


static int myaverage_new(int arr[], int size) 
{
  int i, sum = 0;
  
  int avg;
  int adjustvalue = 0;

  for (i = 0; i < size; i++) {
    int modvalue;
    // sum += arr[i];
    modvalue = arr[i] - arr[0];
    sum += modvalue;
  }
  adjustvalue = sum / size;
  avg = arr[0] + adjustvalue;
  return avg;
}



static void drv_fillraw_adc_value_to_adcbuf(void) 
{

  int temp_adcvalue=0;
  int raw_adc_averdge = 0;
  //uint8_t current_i = 0;
  

    
  for (int i = 0; i < ADCMAXCOUNT; i++) 
  {
       
       adcarray[i] = analogRead(35);
       //Serial.printf("[drv_fillraw_adc_value_to_adcbuf line 143]->adcarray[%d]=%d.",i,adcarray[i]);
      delay(2);
  }



    //Serial.printf("[fillraw_adc_value_to_adcbuf]raw_value->analogRead(35)=:%d  \n", adcarray[i]);


  /////////////get vergin_average_value/////////////////////////
  
////////////就像评委打分一样去掉一个最高分，去掉一个最地方算出来的值更加稳定准确///////////////////
//挑第1轮最大值   begin///////////////////////////////////////////////////
  ///////////////get max adc///////////////////////
  int max = adcarray[0];
  for (int i = 0; i < ADCMAXCOUNT; i++) 
  {
    if (max < adcarray[i]) {
      max = adcarray[i];
    }
  }
  //kickoff max adc////////
  raw_adc_averdge = myaverage_new(adcarray, ADCMAXCOUNT);
  for (int i = 0; i < ADCMAXCOUNT; i++) 
  {
    if (max == adcarray[i]) 
    {
       adcarray[i]=raw_adc_averdge;
    }
  }
 //挑第1轮最大值 end////////////////////////////////////////////

//挑第2轮最大值   begin///////////////////////////////////////////////////
max = adcarray[0];
  for (int i = 0; i < ADCMAXCOUNT; i++) 
  {
    if (max < adcarray[i]) {
      max = adcarray[i];
    }
  }
  //kickoff max adc////////
  raw_adc_averdge = myaverage_new(adcarray, ADCMAXCOUNT);
  for (int i = 0; i < ADCMAXCOUNT; i++) 
  {
    if (max == adcarray[i]) 
    {
       adcarray[i]=raw_adc_averdge;
    }
  }
  //挑第2轮最大值 end////////////////////////////////////////////


//挑第3轮最大值  begin/////////////////////////////////////////////////
  ///////////////get max adc///////////////////////
  //int max = adcarray[0];
  max = adcarray[0];
  for (int i = 0; i < ADCMAXCOUNT; i++) 
  {
    if (max < adcarray[i]) {
      max = adcarray[i];
    }
  }
  //kickoff max adc////////

  raw_adc_averdge = myaverage_new(adcarray, ADCMAXCOUNT);
  for (int i = 0; i < ADCMAXCOUNT; i++) 
  {
    if (max == adcarray[i]) {
       adcarray[i]=raw_adc_averdge;
    }
  }
  //挑第3轮最大值 end////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////

//挑第1轮最小值  begin/////////////////////////////////////////////////
  //////////////get min adc//////////////////////////////
  int min = adcarray[0];
  for (int i = 0; i < ADCMAXCOUNT; i++) 
  {
    if (min > adcarray[i]) {
      min = adcarray[i];
    }
  }
  /////////////////////kickoff min adc value///////////////////////////////////

  raw_adc_averdge = myaverage_new(adcarray, ADCMAXCOUNT);
  for (int i = 0; i < ADCMAXCOUNT; i++) {
    if (min == adcarray[i]) 
    {
      adcarray[i] = raw_adc_averdge;
    }
  }
  //挑第1轮最小值 end////////////////////////////////////////////



  //挑第2轮最小值  begin/////////////////////////////////////////////////
    //////////////ge min adc//////////////////////////////
   min = adcarray[0];
  for (int i = 0; i < ADCMAXCOUNT; i++) 
  {
    if (min > adcarray[i]) {
      min = adcarray[i];
    }
  }
  /////////////////////kickoff min adc value///////////////////////////////////

  raw_adc_averdge = myaverage_new(adcarray, ADCMAXCOUNT);
  for (int i = 0; i < ADCMAXCOUNT; i++) {
    if (min == adcarray[i]) 
    {
      adcarray[i] = raw_adc_averdge;
    }
  }
  //挑第2轮最小值 end////////////////////////////////////////////

  //挑第3轮最小值  begin/////////////////////////////////////////////////
    //////////////ge min adc//////////////////////////////
   min = adcarray[0];
  for (int i = 0; i < ADCMAXCOUNT; i++) 
  {
    if (min > adcarray[i]) 
    {
      min = adcarray[i];
    }
  }
  /////////////////////kickoff min adc value///////////////////////////////////

  raw_adc_averdge = myaverage_new(adcarray, ADCMAXCOUNT);
  for (int i = 0; i < ADCMAXCOUNT; i++) {
    if (min == adcarray[i]) 
    {
      adcarray[i] = raw_adc_averdge;
    }
  }
  //挑第3轮最小值 end////////////////////////////////////////////
  
  ///////////////////refresh average_value///////////////////////
  steady_average_adcvalue = myaverage_new(adcarray, ADCMAXCOUNT);
  //Serial.printf("[drv_fillraw_adc_value_to_adcbuf line 282]->steady_average_adcvalue=%d\n",steady_average_adcvalue);
}  //end  fillraw_adc_value_to_adcarray


int adc_class::get_average_adcvalue(void)
{
    int rc;
    rc=drv_get_average_adcvalue();
    return rc;
}

void adc_class::fillraw_adc_value_to_adcbuf(void)
{
   
    drv_fillraw_adc_value_to_adcbuf();
    return ;
}

float adc_class::get_ADCchangetocurrent(uint16_t adcvalue)
{ 
    float ai_value;

    ai_value=drv_get_ADCchangetocurrent(adcvalue);
   
    return ai_value;
}


