/***************************************************************************************************
                                    ExploreEmbedded Copyright Notice    
****************************************************************************************************
 * File:   atcommand.cpp
 * Version: 1.0
 * Author: ExploreEmbedded
 * Website: http://www.exploreembedded.com/wiki
 * Description: ESP32  Arduino library for AWS IOT.
 
This code has been developed and tested on ExploreEmbedded boards.  
We strongly believe that the library works on any of development boards for respective controllers. 
Check this link http://www.exploreembedded.com/wiki for awesome tutorials on 8051,PIC,AVR,ARM,Robotics,RTOS,IOT.
ExploreEmbedded invests substantial time and effort developing open source HW and SW tools, to support consider buying the ExploreEmbedded boards.
 
The ExploreEmbedded libraries and examples are licensed under the terms of the new-bsd license(two-clause bsd license).
See also: http://www.opensource.org/licenses/bsd-license.php

EXPLOREEMBEDDED DISCLAIMS ANY KIND OF HARDWARE FAILURE RESULTING OUT OF USAGE OF LIBRARIES, DIRECTLY OR
INDIRECTLY. FILES MAY BE SUBJECT TO CHANGE WITHOUT PRIOR NOTICE. THE REVISION HISTORY CONTAINS THE INFORMATION 
RELATED TO UPDATES.
 

Permission to use, copy, modify, and distribute this software and its documentation for any purpose
and without fee is hereby granted, provided that this copyright notices appear in all copies 
and that both those copyright notices and this permission notice appear in supporting documentation.
**************************************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdio.h>
#include <Arduino.h>
#include <system_parameter.h>
#include <parameter_config.h>

system_parameter eg118_system_parameter_at_module;

#include <drv74hc595.h>
 //drv74hc595class at_module_drv74hc595;

#include<drvdout.h>

 drvout_class at_module_drvout;

#include <adc.h>
 adc_class at_module_adc;


#include <RS485.h>
#include <WiFi.h>
#include <esp_wifi.h>
#include <eg118setting.h>


#include "atcommand.h"
#define RELOAD_DOG_PIN 3
#define RX1PIN GPIO_NUM_33
#define TX1PIN GPIO_NUM_32

#define COMMANDBUFSIZE 150
static unsigned char newcomnandcheck_flag = 0;
char command_string[COMMANDBUFSIZE];
int command_index = 0;

int8_t  gv_stawifi_rssi=-1;


static unsigned char atmodule_connect_mode = 0;
static unsigned char atmodule_device_mode = 0;

extern const char *eg118softversion ;
extern IPAddress gv_apGateway;
extern IPAddress gv_apSubNet;


// const char *at_help_info="AT+WFWANN[?]\n/
// AT+WFWANN:192.168.1.1,255.255.255.0,192.168.1.1
// AT+SN[?]\n
// AT+SN:800624121300009452
// AT+WIFI[?]\n
// AT+WIFI:wifi mode:AP ipaddress:192.168.1.1
// AT+VER[?]\n
// AT+VER:+VER:EG118_1213
// AT+BUILDTIME[?]\n
// AT+BUILDTIME:2024-01-03-16:08:20
// AT+WIFI_STA_MAC[?]\n
// AT+WIFI_STA_MAC[?]:00004AD208FB";

 char *at_help_info="AT+WFWANN[?]-AT+SN[?]-AT+WIFI[?]-AT+VER[?]-AT+BUILDTIME[?]-AT+NET[?]-AT+MUVER[?]";
                    


static void reload_dog(void) 
{


  pinMode(RELOAD_DOG_PIN, OUTPUT);
  digitalWrite(RELOAD_DOG_PIN, 0);
  delay(10);
  digitalWrite(RELOAD_DOG_PIN, 1);
  delay(25);
  digitalWrite(RELOAD_DOG_PIN, 0);
  delay(10);
}

static void adjustarray(char arr[], unsigned char size) 
{
  //修正字符串里面的换行符
  for (int j = 0; j < size; j++) 
  {
    if (10 == arr[j]) 
    {
      arr[j] = 0;
    }
  }
}
static void response_newcommandok(char *pstr_targetcommand) 
{
  char responsestr[50];
  snprintf(responsestr, 50, "%s : ok\n", pstr_targetcommand);
  //return 1;
  RS485.noReceive();
  RS485.beginTransmission();
  Serial.printf("[loop_line_1113]->RS485.beginTransmission():%s\n", responsestr);

  for (int i = 0; i < strlen(responsestr); i++) 
  {
    RS485.beginTransmission();
    RS485.write(responsestr[i]);
    RS485.endTransmission();
    delay(5);
  }
}
static int response_newcommandfail(char *pstr_targetcommand) 
{
  char responsestr[20];
  snprintf(responsestr, 20, "<%s>->[fail]", pstr_targetcommand);
  RS485.noReceive();
  RS485.beginTransmission();
  Serial.printf("[loop_line_1141]->RS485.beginTransmission():%s\n", responsestr);

  for (int i = 0; i < strlen(responsestr); i++) {
    RS485.beginTransmission();
    RS485.write(responsestr[i]);
    RS485.endTransmission();
    delay(5);
  }
}  //response_newcommandfail

void response_newcommandresult(char *pstr_targetcommand, char *str_result) 
{
  char responsestr[100];
  memset(responsestr, 0, 100);
  // Serial.printf("LINE 2555 pstr_targetcommand->      %s\n", pstr_targetcommand);
  //Serial.printf("LINE 2556 str_result->      %s\n", str_result);
  snprintf(responsestr, 100, "%s:%s\n", pstr_targetcommand, str_result);
  //return 1;
  RS485.noReceive();

  //Serial.printf("[LINE 2296 responsestr ]->:%s\n", responsestr);
  RS485.beginTransmission();

  for (int i = 0; i < strlen(responsestr); i++) {
    RS485.beginTransmission();
    RS485.write(responsestr[i]);
    RS485.endTransmission();
    delay(5);
  }
  //Serial.println("response_newcommandresult  end");
}

static int pickoutnewcommandparameter_equalssign(char arr[]) 
{
  char *pstr_pickoutparameter_start = strstr(command_string, "=");
  //char *pstr_pickoutparameter_end = NULL;
  if (NULL == pstr_pickoutparameter_start) {
    return -1;
  }


  pstr_pickoutparameter_start++;
  strcpy(arr, pstr_pickoutparameter_start);


  return 1;
}

static int pickoutnewcommandparameter_brackets(char arr[]) 
{
  unsigned char parameterlength = 0;
  char *pstr_pickoutparameter_start = NULL;
  char *pstr_pickoutparameter_end = NULL;
  //char _paraarraytemp[10];

  pstr_pickoutparameter_start = strstr(command_string, "<");
  if (NULL == pstr_pickoutparameter_start) {
    Serial.printf("[pstr_pickoutparameter_start is NULL\n");
    return -1;
  }
  // Serial.printf("[pickoutnewcommandparameterLINE 1610]command_string->  %s\n", command_string);
  //Serial.printf("[pickoutnewcommandparameter]pstr_pickoutparameter_start=%X\n", pstr_pickoutparameter_start);

  pstr_pickoutparameter_end = strstr(command_string, ">");
  //Serial.printf("[pickoutnewcommandparameter]pstr_pickoutparameter_end=%X\n", pstr_pickoutparameter_end);
  if (NULL == pstr_pickoutparameter_end) {
    Serial.printf("[pstr_pickoutparameter_end is NULL\n");
    return -1;
  }
  parameterlength = pstr_pickoutparameter_end - pstr_pickoutparameter_start - 1;
  Serial.printf("[parameterlength is %d\n", parameterlength);
  if (0 == parameterlength) {
    Serial.printf("[parameterlength is 0\n");
    return -1;
  }
  pstr_pickoutparameter_start++;
  strncpy(arr, pstr_pickoutparameter_start, parameterlength);
  //memcpy(gv_paraarray,pstr_pickoutparameter_start,parameterlength);

  //snprintf(_paraarraytemp,10,"%s",pstr_pickoutparameter_start);
  //Serial.printf("LINE 1766 parameter->      %s\n",arr);
  Serial.printf("LINE 1767 parameter->      %s\n", arr);

  return 1;
}



static void ereasecustom_info(void) 
{
  //清除用户模式，不要透传模式,默认串口at命令
  //默认ap模式
  // refreshEEPROMRAM();
  eg118_system_parameter_at_module.set_wifi_status(EEPROM_WIFI_AP_MODE);

  eg118_system_parameter_at_module.set_deviceMode_AT_MODE();
  
  eg118_system_parameter_at_module.set_CONNECT_TO_NET_WITH_WIFIMODE();
  //顺便把dout灯灭了。
  at_module_drvout.M100DOU1_OFF();
  at_module_drvout.M100DOU2_OFF();
 
}
static void setbasemac_stringto_esp32chip(char base_macstring[])
 {
  uint8_t base_mac[6];
  int errorret = 0;
  //char custombase_macstring[12];
  char mac_field[3];
  char *endptr;
  
  uint8_t newMACAddress[6];
  //uint8_t setwifimac[6];
  memset(newMACAddress, 0, 6);
  memset(newMACAddress, 0, 6);
  //EEPROM_get_basemac_string(custombase_macstring);
  for (int i = 0; i < 6; i++) {
    long value;
    mac_field[0] = base_macstring[2 * i];
    mac_field[1] = base_macstring[2 * i + 1];
    mac_field[2] = 0;
    //Serial.printf("[setbasemac_string]line  2017          tempmac  %s, \n", tempmac);
    value = strtol(mac_field, &endptr, 16);
    base_mac[i] = value;
  }
  // newebase_mac[0] = newebase_mac[0] & 0xfe;
  errorret = esp_base_mac_addr_set(base_mac);
  #ifdef LOG_ENABLE
  Serial.printf("[setbasemac_string]============LINE 1953->errorret= %d->base_macstring%s\n",errorret, base_macstring);
  #endif

}
static int pickoutnewcommand_nocleanlastcommand(char *pstr_targetcommand) 
{
  char *pstr_pickoutcommand = NULL;

  pstr_pickoutcommand = strstr(command_string, pstr_targetcommand);
  if (NULL != pstr_pickoutcommand) {
    return 1;
  } else {
    return -1;
  }
}

void cleancommandlist(void) 
{
  newcomnandcheck_flag = 0;
  memset(command_string, 0, COMMANDBUFSIZE);
  command_index = 0;
}
static int pickoutnewcommand(char *pstr_targetcommand) 
{
  char *pstr_pickoutcommand = NULL;
  pstr_pickoutcommand = strstr(command_string, pstr_targetcommand);
  if (NULL != pstr_pickoutcommand) {
    //Serial.printf("%s\n",command_string);
    newcomnandcheck_flag = 0;
    memset(pstr_pickoutcommand, 0, strlen(pstr_targetcommand));

    //Serial.println("pickoutnewcommand->memset(command_string,0,100)");
    memset(command_string, 0, 100);
    command_index = 0;
    return 1;
  } else {
    return -1;
  }
}

void at_device_init(void)
{
   atmodule_device_mode = eg118_system_parameter_at_module.GetdeviceMode();
   atmodule_connect_mode = eg118_system_parameter_at_module.GetconnectMode();
  
  Serial1.begin(115200, SERIAL_8N1, RX1PIN, TX1PIN);
  reload_dog();
  //Serial.println("line 1604  [ModbusRTUClient.begin]");
  RS485.begin(115200);

}


void polling_atcommandlist(void) 
{
  if (1 == pickoutnewcommand_nocleanlastcommand("AT+WIFISSID")) 
  {
    char WIFIssid_array[WIFI_SSIDstring_length_MAX];
    unsigned char ssid_length = 0;
    memset(WIFIssid_array, 0, WIFI_SSIDstring_length_MAX);
    pickoutnewcommandparameter_equalssign(WIFIssid_array);
    //修正字符串里面的换行符
    for (int j = 0; j < WIFI_SSIDstring_length_MAX; j++) {
      if (10 == WIFIssid_array[j]) {
        WIFIssid_array[j] = 0;
      }
    }

    cleancommandlist();
    eg118_system_parameter_at_module.set_wifi_status(EEPROM_WIFI_STA_MODE);

    ssid_length = strlen(WIFIssid_array);
    eg118_system_parameter_at_module.setpoweronwifiSSIDlength(ssid_length);
    eg118_system_parameter_at_module.setpoweronwifiSSIDstr(WIFIssid_array, ssid_length);

    if (ssid_length > 0) {
      response_newcommandok("AT+WIFISSID");
    }
  }
  if (1 == pickoutnewcommand("AT+WIFIRSSI[?]")) 
    {
    char RSSI_array[20];
    
    memset(RSSI_array,0,20);
    snprintf(RSSI_array,20,"%d",WiFi.RSSI());
    response_newcommandresult("AT+WIFIRSSI", RSSI_array);
  }

  if (1 == pickoutnewcommand_nocleanlastcommand("AT+PASS")) {
    char WIFIPASSWARD_array[WIFI_PASSWARD_LENGTH_MAX];
    unsigned char pass_length = 0;
    //char testinfo[60];
    memset(WIFIPASSWARD_array, 0, WIFI_PASSWARD_LENGTH_MAX);
    pickoutnewcommandparameter_equalssign(WIFIPASSWARD_array);
    //修正字符串里面的换行符
    for (int j = 0; j < WIFI_PASSWARD_LENGTH_MAX; j++) {
      if (10 == WIFIPASSWARD_array[j]) {
        WIFIPASSWARD_array[j] = 0;
      }
    }
    cleancommandlist();
    //refreshEEPROMRAM();
    eg118_system_parameter_at_module.set_wifi_status(EEPROM_WIFI_STA_MODE);
    //EEPROM_setwifi_passward_length(8);
    pass_length = strlen(WIFIPASSWARD_array);
    //EEPROM_setwifi_passward_length(pass_length);
    eg118_system_parameter_at_module.setwifi_password_length(pass_length);
    //Serial.printf("LINE 3539 strlen(WIFIPASSWARD_array)=%d", strlen(WIFIPASSWARD_array));
    //EEPROM_setwifi_passward_str(WIFIPASSWARD_array, pass_length);
    eg118_system_parameter_at_module.setwifi_password_str(WIFIPASSWARD_array, pass_length);
    //update_RAM_toEEPROM();
    //drv_M100DOU2_ON();
    if (pass_length > 0) {
      response_newcommandresult("AT+PASS", WIFIPASSWARD_array);
    }
    // snprintf(testinfo,60,"pass_length=%d WIFIPASSWARD_array=%s\n",pass_length,WIFIPASSWARD_array);
    //response_newcommandresult("AT+PASS", testinfo);
  }

  if (1 == pickoutnewcommand_nocleanlastcommand("AT+TCPIP")) {
    char TCPIP_array[20];
    memset(TCPIP_array, 0, 20);
    pickoutnewcommandparameter_equalssign(TCPIP_array);
    //修正字符串里面的换行符
    for (int j = 0; j < 20; j++) {
      if (10 == TCPIP_array[j]) {
        TCPIP_array[j] = 0;
      }
    }
    cleancommandlist();

    eg118_system_parameter_at_module.parameter_refreshEEPROMRAM();
    //EEPROM_setdeviceMode_TCP_DTU_ONLY();
    eg118_system_parameter_at_module.set_deviceMode_TCP_DTU_ONLY();
    //EEPROM_set_tcpserver_ip_length(strlen(TCPIP_array));
    eg118_system_parameter_at_module.set_tcpserver_ip_length(strlen(TCPIP_array));
    //EEPROM_set_tcpserver_ip_string(TCPIP_array, strlen(TCPIP_array));
    eg118_system_parameter_at_module.set_tcpserver_ip_string(TCPIP_array, strlen(TCPIP_array));
    //update_RAM_toEEPROM();
    at_module_drvout.M100DOU2_ON();
    Serial.printf("LINE 2964 TCPIP_array=%s", TCPIP_array);
    response_newcommandresult("AT+TCPIP", TCPIP_array);
  }
  if (1 == pickoutnewcommand_nocleanlastcommand("AT+TCPPORT")) {
    char TCPPORT_array[4];
    unsigned char tcpserver_port_length;
    memset(TCPPORT_array, 0, 4);
    pickoutnewcommandparameter_equalssign(TCPPORT_array);
    //修正字符串里面的换行符
    for (int j = 0; j < 4; j++) {
      if (10 == TCPPORT_array[j]) {
        TCPPORT_array[j] = 0;
      }
    }
    cleancommandlist();
    //refreshEEPROMRAM();
    eg118_system_parameter_at_module.parameter_refreshEEPROMRAM();
    tcpserver_port_length = strlen(TCPPORT_array);
    //EEPROM_set_tcpserver_port_length(strlen(TCPPORT_array));

    eg118_system_parameter_at_module.set_tcpserver_port_length(tcpserver_port_length);
    //EEPROM_set_tcpserver_port__string(TCPPORT_array, strlen(TCPPORT_array));
    eg118_system_parameter_at_module.set_tcpserver_port__string(TCPPORT_array, tcpserver_port_length);
    //update_RAM_toEEPROM();
    at_module_drvout.M100DOU2_ON();
    Serial.printf("LINE 2495 TCPIP_array=%s", TCPPORT_array);
    response_newcommandresult("AT+TCPPORT", TCPPORT_array);
  }



  if (1 == pickoutnewcommand("AT+RELOAD")) {

    //irqtesthandle2();

    ereasecustom_info();



    response_newcommandok("AT+RELOAD");
    //response_newcommandresult("AT+FACTORY", apmodeswitcharray);
  }

  
  if (1 == pickoutnewcommand("AT+NETWIFI")) 
  {
    eg118_system_parameter_at_module.set_CONNECT_TO_NET_WITH_WIFIMODE();
    response_newcommandok("AT+NETWIFI");
  }
    if (1 == pickoutnewcommand("AT+NETETH")) 
  {
    eg118_system_parameter_at_module.set_CONNECT_TO_NET_WITH_ETHERNETMODE();
    response_newcommandok("AT+NETETH");
  }
    if (1 == pickoutnewcommand("AT+NET[?]")) 
    {
    char connect_mode_array[20];
    int connectmode=eg118_system_parameter_at_module.GetconnectMode();
    memset(connect_mode_array,0,20);
    snprintf(connect_mode_array,20,"%d",connectmode);
    response_newcommandresult("AT+NET", connect_mode_array);
  }
  

  if (1 == pickoutnewcommand("AT+SET_BIG_CURRENT")) {
    int bigadcvalue;
    char big_adc_array[18];

    //fillraw_adc_value_to_adcbuf();
    at_module_adc.fillraw_adc_value_to_adcbuf();
    
   
    //bigadcvalue = get_average_adcvalue();
    bigadcvalue = at_module_adc.get_average_adcvalue();
    //bigadcvalue=1121;
    //refreshEEPROMRAM();
    eg118_system_parameter_at_module.parameter_refreshEEPROMRAM();
    //EEPROM_set_BIGCURRENT_ADC(bigadcvalue);
    eg118_system_parameter_at_module.set_bigcurrent_adc(bigadcvalue);
    Serial.printf("line  3299   bigadcvalue=%d\n\n", bigadcvalue);
    Serial.printf("line  3300   bigadcvalue=0x%x\n\n", bigadcvalue);

    snprintf(big_adc_array, 18, "bigadcvalue=%d", bigadcvalue);
    response_newcommandok("AT+SET_BIG_CURRENT");
    // response_newcommandresult("AT+SET_BIG_CURRENT",big_adc_array);
  }
  if (1 == pickoutnewcommand("AT+SET_CURRENT_ADC_INITIAL")) {

    eg118_system_parameter_at_module.set_current_initialadc();

    //refreshEEPROMRAM();
    response_newcommandok("AT+SET_CURRENT_ADC_INITIAL");
  }
  if (1 == pickoutnewcommand("AT+SET_SMALL_CURRENT")) {
    char small_adc_array[18];
    int smalladc = 0;
    //fillraw_adc_value_to_adcarray();
    //fillraw_adc_value_to_adcbuf();
    at_module_adc.fillraw_adc_value_to_adcbuf();
    //smalladc = get_average_adcvalue();
    smalladc = at_module_adc.get_average_adcvalue();
    //smalladc=284;
    //refreshEEPROMRAM();
    eg118_system_parameter_at_module.parameter_refreshEEPROMRAM();
    //EEPROM_set_SMALLCURRENT_ADC(smalladc);
    eg118_system_parameter_at_module.set_smallcurrent_adc(smalladc);
    // irqtesthandle2();

    //update_RAM_toEEPROM();
    response_newcommandok("AT+SET_SMALL_CURRENT");
    snprintf(small_adc_array, 18, "smalladc=%d", smalladc);
    //response_newcommandresult("AT+SET_SMALL_CURRENT",small_adc_array);
  }


  if (1 == pickoutnewcommand_nocleanlastcommand("AT+SETSN")) {
    char mym100_sn_array[M100_SN_LENGTH_MAX];
    int snlength = 0;
    memset(mym100_sn_array, 0, M100_SN_LENGTH_MAX);
    pickoutnewcommandparameter_equalssign(mym100_sn_array);
    cleancommandlist();

    //修正字符串里面的换行符
    adjustarray(mym100_sn_array,M100_SN_LENGTH_MAX);

    //EEPROM_set_M100SNr_length(strlen(mym100_sn_array));
    snlength = strlen(mym100_sn_array);
    if (snlength>M100_SN_LENGTH_MAX)
    {
      snlength=M100_SN_LENGTH_MAX;
    }
    eg118_system_parameter_at_module.set_sn_length(snlength);
    //EEPROM_set_M100SNr_string(mym100_sn_array, strlen(mym100_sn_array));
    eg118_system_parameter_at_module.set_M100SNr_string(mym100_sn_array, snlength);
    
    response_newcommandresult("AT+SETSN", mym100_sn_array);
  }

  if (1 == pickoutnewcommand_nocleanlastcommand("AT+TESTDO")) {
    char testDOUT_array[10];
    memset(testDOUT_array, 0, 10);
    //char debug74hc595value[20];
    //memset(debug74hc595value, 0, 20);
    pickoutnewcommandparameter_equalssign(testDOUT_array);
    //修正字符串里面的换行符
    for (int j = 0; j < 10; j++) {
      if (10 == testDOUT_array[j]) {
        testDOUT_array[j] = 0;
      }
    }
    cleancommandlist();
    // for (int i = 0; i < 2; i++)
    //{

    if (testDOUT_array[0] == '1') {
      if (testDOUT_array[1] == '1') {
        at_module_drvout.M100DOUT_1_on_and_2_on();

      } else {
        at_module_drvout.M100DOUT_1_on_and_2_off();
      }

    } else {
      if (testDOUT_array[1] == '1') {
        at_module_drvout.M100DOUT_1_off_and_2_on();

      } else {
        at_module_drvout.M100DOUT_1_off_and_2_off();
      }
    }
    // snprintf(debug74hc595value,20,"[%s]  0x%x ",testDOUT_array,gv_74HC595schipvalue);
    Serial.printf(" LINE 3372  AT+TESTDO=%s\n", testDOUT_array);
    response_newcommandresult("AT+TESTDO", testDOUT_array);
  }

  if (1 == pickoutnewcommand("AT+TESTDI")) {
    char testDIN_array[2];
    memset(testDIN_array, 0, 2);
    pinMode(39, INPUT);
    if (1 == digitalRead(39)) {
      testDIN_array[0] = '1';

    } else {
      testDIN_array[0] = '0';
    }
    response_newcommandresult("AT+TESTDI", testDIN_array);
  }



  if (1 == pickoutnewcommand("reload_wifi_softap")) {
    eg118_system_parameter_at_module.set_wifi_status(EEPROM_WIFI_AP_MODE);
    //update_RAM_toEEPROM();
    response_newcommandok("reload_wifi_softap");
  }


  if (1 == pickoutnewcommand_nocleanlastcommand("AT+SET_BASE_MAC")) {
    char base_mac_array[15];
    unsigned char maclength = 0;
    memset(base_mac_array, 0, 15);
    pickoutnewcommandparameter_equalssign(base_mac_array);
    //修正字符串里面的换行符
    for (int j = 0; j < 15; j++) {
      if (10 == base_mac_array[j]) {
        base_mac_array[j] = 0;
      }
    }
    cleancommandlist();

    maclength = strlen(base_mac_array);
    if (maclength > BASE_MAC_LENGTH) {
      maclength = BASE_MAC_LENGTH;
    }
    //EEPROM_set_set_base_mac_length(maclength);
    eg118_system_parameter_at_module.set_basemac_length(maclength);
    //EEPROM_set_base_mac_string(base_mac_array, maclength,maclength);
    eg118_system_parameter_at_module.set_M100basemac_string(base_mac_array, maclength);
    //EEPROM_set_base_mac_string(base_mac_array);

    Serial.printf(" LINE 3372  AT+SET_BASE_MAC=%s\n", base_mac_array);

    // update_RAM_toEEPROM();
    //writecustommactowifi();
    setbasemac_stringto_esp32chip(base_mac_array);
    response_newcommandresult("AT+SET_BASE_MAC", base_mac_array);
  }
  if (1 == pickoutnewcommand_nocleanlastcommand("AT+setMUVER")) {
    char muver_array[M100_MUVER_LENGTH_MAX];
    int mulength = 0;
    memset(muver_array, 0, M100_MUVER_LENGTH_MAX);
    pickoutnewcommandparameter_equalssign(muver_array);
    //修正字符串里面的换行符
    for (int j = 0; j < M100_MUVER_LENGTH_MAX; j++) {
      if (10 == muver_array[j]) {
        muver_array[j] = 0;
      }
    }
    cleancommandlist();
    //EEPROM_set_set_M100_MUVER_length(strlen(muver_array));
    mulength = strlen(muver_array);
    eg118_system_parameter_at_module.set_m100muver_length(mulength);
    eg118_system_parameter_at_module.set_m100muver_string(muver_array, mulength);
    //EEPROM_set_M100_MUVER_string(muver_array, strlen(muver_array));
    Serial.printf("[polling_atcommandlist line 3419]->muver_array->%s\n", muver_array);
    //update_RAM_toEEPROM();
    response_newcommandresult("AT+setMUVER", muver_array);
  }

  if (1 == pickoutnewcommand("AT+WIFI_STA_MAC[?]")) {
    uint8_t wifi_sta_mac[6];
    // uint8_t wifi_ap_mac[6];
    char wifi_sta_macstring[20];
    char wifi_ap_macstring[20];
    memset(wifi_sta_macstring, 0, 20);
    memset(wifi_ap_macstring, 0, 20);
    memset(wifi_sta_mac, 0, 6);
    esp_read_mac(wifi_sta_mac, ESP_MAC_WIFI_STA);
#if 0
    wifi_sta_mac[0]=0xd4;
    wifi_sta_mac[1]=0xad;
    wifi_sta_mac[2]=0x20;
    wifi_sta_mac[3]=0;
    wifi_sta_mac[4]=0x88;
    wifi_sta_mac[5]=0x37;
#endif


    //  Serial.printf("[wifi_sta_mac[0]=%2X  [wifi_sta_mac[1]=%2X  [wifi_sta_mac[2]=%2X,[wifi_sta_mac[3]=%2X\n", wifi_sta_mac[0],wifi_sta_mac[1],[wifi_sta_mac[2],[wifi_sta_mac[3]);
    snprintf(wifi_sta_macstring, 20, "%02X%02X%02X%02X%02X%02X\n", wifi_sta_mac[0], wifi_sta_mac[1], wifi_sta_mac[2], wifi_sta_mac[3], wifi_sta_mac[4], wifi_sta_mac[5]);
    response_newcommandresult("AT+WIFI_STA_MAC[?]", wifi_sta_macstring);
  }
  if (1 == pickoutnewcommand("AT+WIFI_AP_MAC[?]")) {
    uint8_t wifi_ap_mac_hex[6];
    char wifi_ap_macstring[20];
    memset(wifi_ap_macstring, 0, 20);
    esp_read_mac(wifi_ap_mac_hex, ESP_MAC_WIFI_SOFTAP);
    snprintf(wifi_ap_macstring, 20, "%02X%02X%02X%02X%02X%02X\n", wifi_ap_mac_hex[0], wifi_ap_mac_hex[1], wifi_ap_mac_hex[2], wifi_ap_mac_hex[3], wifi_ap_mac_hex[4], wifi_ap_mac_hex[5]);
    response_newcommandresult("AT+WIFI_AP_MAC[?]", wifi_ap_macstring);
  }
  if (1 == pickoutnewcommand("AT+ETH_MAC[?]")) {
    uint8_t ethernet_mac[6];
    char ethernet_macstring[20];
    esp_read_mac(ethernet_mac, ESP_MAC_ETH);
    snprintf(ethernet_macstring, 20, "%02X%02X%02X%02X%02X%02X\n", ethernet_mac[0], ethernet_mac[1], ethernet_mac[2], ethernet_mac[3], ethernet_mac[4], ethernet_mac[5]);
    response_newcommandresult("AT+ETH_MAC[?]", ethernet_macstring);
  }

  if (1 == pickoutnewcommand("AT+SN[?]")) {
    char m100snarray[M100_SN_LENGTH_MAX];
    unsigned char m100SNlength = 0;
    memset(m100snarray, 0, M100_SN_LENGTH_MAX);
    //m100SNlength = EEPROM_getM100SN_length();
    m100SNlength = eg118_system_parameter_at_module.get_sn_length();
    //EEPROM_getm100sn_string(m100snarray, m100SNlength);
    eg118_system_parameter_at_module.getm100sn_string(m100snarray, m100SNlength);
    //修正字符串里面的换行符
    adjustarray(m100snarray, m100SNlength);
    response_newcommandresult("AT+SN", m100snarray);
  }

  if (1 == pickoutnewcommand("AT+BUILDTIME[?]")) {
    char *m100build_time = "2024-01-03-16:08:20";
    response_newcommandresult("AT+BUILDTIME", m100build_time);
  }
  if (1 == pickoutnewcommand("AT+MUVER[?]")) 
  {
    char pruductiondate[M100_MUVER_LENGTH_MAX];
    unsigned char m100muverlength = 0;
    memset(pruductiondate, 0, M100_MUVER_LENGTH_MAX);
    //m100muverlength = EEPROM_getM100_MUVER_length();
    m100muverlength = eg118_system_parameter_at_module.getM100_MUVER_length();
    if ( m100muverlength > M100_MUVER_LENGTH_MAX)
    {
      m100muverlength = M100_MUVER_LENGTH_MAX;
    }
    //EEPROM__getM100_MUVER_string(pruductiondate, m100muverlength);

    eg118_system_parameter_at_module.getM100_MUVER_string(pruductiondate, m100muverlength);
    //修正字符串里面的换行符
    adjustarray(pruductiondate, m100muverlength);
    //Serial.printf("[polling_atcommandlist line 3239]->m100muverlength->%d\n", m100muverlength);
    //Serial.printf("[polling_atcommandlist line 3240]->pruductiondate->%s\n", pruductiondate);
    response_newcommandresult("AT+MUVER", pruductiondate);
  }
  if (1 == pickoutnewcommand("AT+VER[?]")) 
  {
    char hwver[30];
    memset(hwver, 0, 30);
    snprintf(hwver, 30, eg118softversion);
    response_newcommandresult("AT+VER", hwver);
  }
  if (1 == pickoutnewcommand("AT+HELP[?]")) 
  {

    response_newcommandresult("AT+HELP", at_help_info);
  }
  if (1 == pickoutnewcommand("AT+WIFI[?]")) {
    //Serial.printf("[setup]=====LINE 3811->gv_device_mode=%d, \n", gv_device_mode);
    //Serial.printf("[setup]=====LINE 3812->gv_wifi_mode=%d, \n", gv_wifi_mode);
    char WIFIMODEarray[5];
    char WIFISSIDarray[10];
    char WIFIPASSWORDarray[10];
    char resultarray[85];
    unsigned char wifi_mode = 0;
    
    
    memset(WIFIMODEarray, 0, 5);
    memset(WIFISSIDarray, 0, 10);
    memset(WIFIPASSWORDarray, 0, 10);
    memset(resultarray, 0, 85);

    wifi_mode = eg118_system_parameter_at_module.Getpoweron_wifi_status();
    if (EEPROM_WIFI_STA_MODE == wifi_mode) 
    {
      unsigned char ssid_length = 0;
      unsigned char password_length = 0;
      snprintf(WIFIMODEarray, 5, "STA");
      eg118_system_parameter_at_module.parameter_refreshEEPROMRAM();
      ssid_length = eg118_system_parameter_at_module.getwifiSSIDlength();
      eg118_system_parameter_at_module.getpoweronwifiSSID_string(WIFISSIDarray, ssid_length);

      password_length = eg118_system_parameter_at_module.getwifi_password_length();
      eg118_system_parameter_at_module.getwifi_password__string(WIFIPASSWORDarray, password_length);
      adjustarray(WIFISSIDarray, 10);
      adjustarray(WIFIPASSWORDarray, 10);

      snprintf(resultarray, 85, "mode:%s\n ssid_len=%d id->[%s] pass_len=%d pass->[%s]\n", WIFIMODEarray, ssid_length, WIFISSIDarray, password_length, WIFIPASSWORDarray);
      response_newcommandresult("AT+WIFI", resultarray);
    }

    if (EEPROM_WIFI_AP_MODE == wifi_mode) {

      snprintf(WIFIMODEarray, 5, "AP");
      snprintf(resultarray, 60, "wifi mode:%s ipaddress:192.168.1.1\n", WIFIMODEarray);
      response_newcommandresult("AT+WIFI", resultarray);
    }
  }
  if (1 == pickoutnewcommand("AT+CSQ[?]")) {
    char wifi_csqarray[10];
    int8_t wifi_rssi = 0;
    memset(wifi_csqarray, 0, 10);
    wifi_rssi = WiFi.RSSI();
    snprintf(wifi_csqarray, 10, "%d", wifi_rssi);
    response_newcommandresult("AT+CSQ", wifi_csqarray);
  }
  if (1 == pickoutnewcommand("AT+AICURRENT[?]")) {
    char currenti_array[40];
    uint16_t adcvalue;
    uint16_t m100_current_value_fronthalf;
    memset(currenti_array, 0, 40);
    at_module_adc.fillraw_adc_value_to_adcbuf();
    //adcvalue = get_average_adcvalue();
    adcvalue = at_module_adc.get_average_adcvalue();
    //adconce=analogRead(35);
    // adconce=284;
    //memset(currenti_array, 0, 15);
    //irqtesthandle2();
    Serial.printf("line  3569   adcvalue=%d\n\n", adcvalue);
    Serial.printf("line  3570   adcvalue=%d\n\n", adcvalue);
    m100_current_value_fronthalf = at_module_adc.get_ADCchangetocurrent(adcvalue);
    // m100_current_value_backhalf=get_aicurrent_i_value_fractional_part();

    snprintf(currenti_array, 40, "  i=%d uA ", m100_current_value_fronthalf);
    response_newcommandresult("AT+AICURRENT", currenti_array);
  }
  if (1 == pickoutnewcommand("AT+CPUID")) {
    char chipidarray[80];
    uint32_t chipId = 0;
    memset(chipidarray, 0, 80);
    for (int i = 0; i < 17; i = i + 8) {
      chipId |= ((ESP.getEfuseMac() >> (40 - i)) & 0xff) << i;
    }
    snprintf(chipidarray, 80, "0x%x\n", chipId);
    response_newcommandresult("AT+CPUID", chipidarray);
  }
  if (1 == pickoutnewcommand("AT+Z")) {

    response_newcommandok("AT+Z");
    esp_restart();
  }
  if (1 == pickoutnewcommand("AT+WANN[?]")) {
    #ifdef PHYTESTSAMPLE_ENABLE
    char phy_ip_array[20];
    char phy_mask_array[20];
    char phy_gateway_array[20];
    char at_result_array[60];
    IPAddress phy_ip;
    IPAddress mask_ip;
    IPAddress gateway_ip;
    String phy_ipstring;
    String mask_ipstring;
    String gateway_ipstring;

    phy_ip = ETH.localIP();
    phy_ipstring = phy_ip.toString();
    phy_ipstring.toCharArray(phy_ip_array, 20, 0);

    mask_ip = ETH.subnetMask();
    mask_ipstring = mask_ip.toString();
    mask_ipstring.toCharArray(phy_mask_array, 20, 0);

    gateway_ip = ETH.gatewayIP();
    gateway_ipstring = gateway_ip.toString();
    gateway_ipstring.toCharArray(phy_gateway_array, 20, 0);
    snprintf(at_result_array, 60, "%s,%s,%s", phy_ip_array, phy_mask_array, phy_gateway_array);
    response_newcommandresult("AT+WANN", at_result_array);
    #endif
  }
  if (1 == pickoutnewcommand("AT+WFWANN[?]")) {
    char ip_array[20];
    char mask_array[20];
    char gateway_array[20];
    char at_result_array[60];
    IPAddress wifi_ip;
    IPAddress mask_ip;
    IPAddress gateway_ip;
    String wifi_ipstring;
    String mask_ipstring;
    String gateway_ipstring;
     unsigned char wifi_mode = 0;
     wifi_mode = eg118_system_parameter_at_module.Getpoweron_wifi_status();
    if (wifi_mode == EEPROM_WIFI_STA_MODE) {
      wifi_ip = WiFi.localIP();
      mask_ip = WiFi.subnetMask();
      gateway_ip = WiFi.gatewayIP();
    } else {
      wifi_ip = WiFi.softAPIP();
      mask_ip = WiFi.softAPSubnetMask();
      gateway_ip = gv_apGateway;
    }
    wifi_ipstring = wifi_ip.toString();
    wifi_ipstring.toCharArray(ip_array, 20, 0);


    mask_ipstring = mask_ip.toString();
    mask_ipstring.toCharArray(mask_array, 20, 0);
    gateway_ipstring = gateway_ip.toString();
    gateway_ipstring.toCharArray(gateway_array, 20, 0);
    snprintf(at_result_array, 60, "%s,%s,%s", ip_array, mask_array, gateway_array);
    response_newcommandresult("AT+WFWANN", at_result_array);
  }
}  //polling_atcommandlist

void xTask_atcommand(void *xTask2) 
{
  volatile char read485char = 0;

  //char *findcommandstr;

  
  while (1) {
    //Serial.printf("xTask_atcommand\n");
    ////////////////////////////////获取串口数据/////////////////////////////////////////////////////
    RS485.receive();
    reload_dog();


    if (RS485.available()) 
    {

      if (command_index < 100) 
      {
        read485char = RS485.read();
        //Serial.printf("%c", read485char);
        //if  (10==read485char) read485char=0;
        if (0 != read485char) {
          command_string[command_index] = read485char;
          command_index++;
        }
      }

      if ('\n' == read485char) {
        polling_atcommandlist();
      }
    }
    ////////////////////////////////获取串口数据 end/////////////////////////////////////////////////////
    ////////////////////////////////解析任务命令begin/////////////////////////////////////////////////////

  }  // while (1)
     ////////////////////////////////解析任务命令 end/////////////////////////////////////////////////////
}  //void xTask_atcommand(void *xTask2)
void at_task_start(void)
{
  if ((DEVICE_Mode_AT_COMMAND == atmodule_device_mode) || (DEVICE_Mode_AT_COMMAND_FALSAH_DEFAULT == atmodule_device_mode)) 
  {
    Serial.println("[setup]========================LINE 2479 ->xTaskCreate xTask_atcommand prio  6\n");

    xTaskCreate(
      xTask_atcommand,   /* Task function. */
      "xTask_atcommand", /* String with name of task. */
      4096,              /* Stack size in bytes. */
      NULL,              /* Parameter passed as input of the task */
      6,                 /* Priority of the task.(configMAX_PRIORITIES - 1 being the highest, and 0 being the lowest.) */
      NULL);
  }
}

int atclass::start(void)
{
    int rc=0;
    at_device_init();
    at_task_start();
    return rc;
}






