/***************************************************************************************************
                                    ExploreEmbedded Copyright Notice    
****************************************************************************************************
 * File:   drvout.cpp
 * Version: 1.0
 * Author: ExploreEmbedded
 * Website: http://www.exploreembedded.com/wiki
 * Description: ESP32  Arduino library for AWS IOT.
 
This code has been developed and tested on ExploreEmbedded boards.  
We strongly believe that the library works on any of development boards for respective controllers. 
Check this link http://www.exploreembedded.com/wiki for awesome tutorials on 8051,PIC,AVR,ARM,Robotics,RTOS,IOT.
ExploreEmbedded invests substantial time and effort developing open source HW and SW tools, to support consider buying the ExploreEmbedded boards.
 
The ExploreEmbedded libraries and examples are licensed under the terms of the new-bsd license(two-clause bsd license).
See also: http://www.opensource.org/licenses/bsd-license.php

EXPLOREEMBEDDED DISCLAIMS ANY KIND OF HARDWARE FAILURE RESULTING OUT OF USAGE OF LIBRARIES, DIRECTLY OR
INDIRECTLY. FILES MAY BE SUBJECT TO CHANGE WITHOUT PRIOR NOTICE. THE REVISION HISTORY CONTAINS THE INFORMATION 
RELATED TO UPDATES.
 

Permission to use, copy, modify, and distribute this software and its documentation for any purpose
and without fee is hereby granted, provided that this copyright notices appear in all copies 
and that both those copyright notices and this permission notice appear in supporting documentation.
**************************************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdio.h>
#include <Arduino.h>
#include <system_parameter.h>
#include <parameter_config.h>

 system_parameter drvout_module_system_parameter;

#include <drv74hc595.h>
drv74hc595class drvout_module_drv74hc595;


#include "drvdout.h"



#define DOU1BIT_SET (1 << 2)
#define DOU1BIT_CLEAR ~(1 << 2)
#define DOU2BIT_SET (1 << 3)
#define DOU2BIT_CLEAR ~(1 << 3)


static void drv_M100DOU1_ON(void) 
{
  unsigned char u8_74HC595schipvalue = 0;
  u8_74HC595schipvalue = drvout_module_system_parameter.get_74HC595CHIP_VALUE();
  u8_74HC595schipvalue = u8_74HC595schipvalue | DOU1BIT_SET;
  drvout_module_drv74hc595.drv_sn74hc595sendbyte(u8_74HC595schipvalue);
  drvout_module_system_parameter.set_74HC595_chipvalue(u8_74HC595schipvalue);
}

static void drv_M100DOU1_OFF(void) 
{
  unsigned char u8_74HC595schipvalue = 0;
  u8_74HC595schipvalue = drvout_module_system_parameter.get_74HC595CHIP_VALUE();
  u8_74HC595schipvalue = u8_74HC595schipvalue & DOU1BIT_CLEAR;
  drvout_module_drv74hc595.drv_sn74hc595sendbyte(u8_74HC595schipvalue);

  drvout_module_system_parameter.set_74HC595_chipvalue(u8_74HC595schipvalue);
}


static void drv_M100DOU2_ON(void) 
{
  unsigned char u8_74HC595schipvalue = 0;
  u8_74HC595schipvalue = drvout_module_system_parameter.get_74HC595CHIP_VALUE();
  u8_74HC595schipvalue = u8_74HC595schipvalue | DOU2BIT_SET;

   drvout_module_drv74hc595.drv_sn74hc595sendbyte(u8_74HC595schipvalue);

   drvout_module_system_parameter.set_74HC595_chipvalue(u8_74HC595schipvalue);
}
static void drv_M100DOU2_OFF() 
{
  unsigned char u8_74HC595schipvalue = 0;
  u8_74HC595schipvalue = drvout_module_system_parameter.get_74HC595CHIP_VALUE();
  u8_74HC595schipvalue = u8_74HC595schipvalue & DOU2BIT_CLEAR;

  drvout_module_drv74hc595.drv_sn74hc595sendbyte(u8_74HC595schipvalue);

  drvout_module_system_parameter.set_74HC595_chipvalue(u8_74HC595schipvalue);
}




void drv_M100DOUT_1_on_and_2_off(void) 
{
  unsigned char u8_74HC595schipvalue = 0;
  u8_74HC595schipvalue = drvout_module_system_parameter.get_74HC595CHIP_VALUE();
  u8_74HC595schipvalue = u8_74HC595schipvalue | DOU1BIT_SET;
  u8_74HC595schipvalue = u8_74HC595schipvalue & DOU2BIT_CLEAR;

  drvout_module_drv74hc595.drv_sn74hc595sendbyte(u8_74HC595schipvalue);

  drvout_module_system_parameter.set_74HC595_chipvalue(u8_74HC595schipvalue);
}

void drv_M100DOUT_1_on_and_2_on(void) {
  unsigned char u8_74HC595schipvalue = 0;
  u8_74HC595schipvalue = drvout_module_system_parameter.get_74HC595CHIP_VALUE();
  u8_74HC595schipvalue = u8_74HC595schipvalue | DOU1BIT_SET;
  u8_74HC595schipvalue = u8_74HC595schipvalue | DOU2BIT_SET;
  drvout_module_drv74hc595.drv_sn74hc595sendbyte(u8_74HC595schipvalue);
  drvout_module_system_parameter.set_74HC595_chipvalue(u8_74HC595schipvalue);
}

void drv_M100DOUT_1_off_and_2_on(void) 
{
  unsigned char u8_74HC595schipvalue = 0;

  u8_74HC595schipvalue = drvout_module_system_parameter.get_74HC595CHIP_VALUE();
  u8_74HC595schipvalue = u8_74HC595schipvalue | DOU2BIT_SET;
  u8_74HC595schipvalue = u8_74HC595schipvalue & DOU1BIT_CLEAR;

  drvout_module_drv74hc595.drv_sn74hc595sendbyte(u8_74HC595schipvalue);
  //EEPROM_set_74HC595_chipvalue(u8_74HC595schipvalue);
  drvout_module_system_parameter.set_74HC595_chipvalue(u8_74HC595schipvalue);
}
void drv_M100DOUT_1_off_and_2_off(void) 
{
  unsigned char u8_74HC595schipvalue = 0;
  u8_74HC595schipvalue = drvout_module_system_parameter.get_74HC595CHIP_VALUE();
  u8_74HC595schipvalue = u8_74HC595schipvalue & DOU1BIT_CLEAR;
  u8_74HC595schipvalue = u8_74HC595schipvalue & DOU2BIT_CLEAR;

  drvout_module_drv74hc595.drv_sn74hc595sendbyte(u8_74HC595schipvalue);
  drvout_module_system_parameter.set_74HC595_chipvalue(u8_74HC595schipvalue);
}


void drvout_class::M100DOU1_ON(void)
{
    
    drv_M100DOU1_ON();
    return ;
}

void drvout_class::M100DOU1_OFF(void)
{
    
    drv_M100DOU1_OFF();
    return ;
}

void drvout_class::M100DOU2_ON(void)
{
 
    drv_M100DOU2_ON();
    return ;
}
void drvout_class::M100DOU2_OFF(void)
{

    drv_M100DOU2_OFF();
    return ;
}


void drvout_class::M100DOUT_1_on_and_2_off(void)
{
   
    drv_M100DOUT_1_on_and_2_off();
    return ;
}

void drvout_class::M100DOUT_1_on_and_2_on(void)
{
 
    M100DOUT_1_on_and_2_on();
    return ;
}

void drvout_class::M100DOUT_1_off_and_2_on(void)
{
 
    drv_M100DOUT_1_off_and_2_on();
    return ;
}

void drvout_class::M100DOUT_1_off_and_2_off(void)
{
  
    drv_M100DOUT_1_off_and_2_off();
    return ;
}





















