/***************************************************************************************************
                                    ExploreEmbedded Copyright Notice    
****************************************************************************************************
 * File:   dtu.cpp
 * Version: 1.0
 * Author: ExploreEmbedded
 * Website: http://www.exploreembedded.com/wiki
 * Description: ESP32  Arduino library for dtu demo .
 

**************************************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdio.h>
#include <Arduino.h>
#include <system_parameter.h>
#include <parameter_config.h>

system_parameter eg118_system_parameter_modbus_demo_module;

#include <RS485.h>
#include <WiFi.h>
#include <esp_wifi.h>

#include <pctool_modbus_demo.h>
#include <PubSubClient.h>
#include "dtu.h"
#define RELOAD_DOG_PIN 3
#define RX1PIN GPIO_NUM_33
#define TX1PIN GPIO_NUM_32

#define SLAVEDEVICEID 1
#define SLAVEDEVICEADDRESS 0
#define BAUD 115200  
#define HODREGCOUNT 10
//extern int gvaddress ;
//extern int gvhold_value ;
int numholdreg = HODREGCOUNT;
const uint8_t gv_deviceID = SLAVEDEVICEID;
static unsigned char device_mode = 0;
 static int modbusdemo_module_holdregisteraddr=2;
 static int modbusdemo_module_holdregistervalue=22;

#include <ModbusTCPClient.h>
WiFiClient eg118wifitcpClient;


ModbusTCPClient modbusTCPClient(eg118wifitcpClient);

IPAddress eg118mModbusTCPClientIP;
uint16_t ModbusTCPClientport=502;
#define RELOAD_DOG_PIN 3

static void reload_dog(void) 
{


  pinMode(RELOAD_DOG_PIN, OUTPUT);
  digitalWrite(RELOAD_DOG_PIN, 0);
  delay(10);
  digitalWrite(RELOAD_DOG_PIN, 1);
  delay(25);
  digitalWrite(RELOAD_DOG_PIN, 0);
  delay(10);
}

static void Modbus_adjustarray(char arr[], unsigned char size) 
{
  //修正字符串里面的换行符
  for (int j = 0; j < size; j++) {
    if (10 == arr[j]) {
      arr[j] = 0;
    }
  }
}
void xTask_modbus_demo_tcp_func(void *xTask1) 
{
  int ret_begin_status;
  #if 1 
   unsigned char modbusserveripstring_length = 0;
  
  char modbusserveripstring[MODBUSTCPSERVERstring_length_MAX];
  

  memset(modbusserveripstring, 0, MODBUSTCPSERVERstring_length_MAX);
  

  eg118_system_parameter_modbus_demo_module.parameter_refreshEEPROMRAM();

  modbusserveripstring_length = eg118_system_parameter_modbus_demo_module.get_modbusserver_ip_length();
  
  if (modbusserveripstring_length>MODBUSTCPSERVERstring_length_MAX)
  {
    modbusserveripstring_length=MODBUSTCPSERVERstring_length_MAX;
  }
  if (modbusserveripstring_length) 
  {
    eg118_system_parameter_modbus_demo_module.get_modbusserver_ip_string(modbusserveripstring, modbusserveripstring_length);
    //修正字符串里面的换行符
    Modbus_adjustarray(modbusserveripstring, modbusserveripstring_length);

    String s = modbusserveripstring;
    eg118mModbusTCPClientIP.fromString(s);
  } 
 #endif 
  ret_begin_status=modbusTCPClient.begin(eg118mModbusTCPClientIP,ModbusTCPClientport);

  reload_dog();
  
  while (1) 
  {
      int modbusClientstatus=0;
      int  RegisterWritestatus=0;
     
      modbusClientstatus=modbusTCPClient.connected();
      if (1==modbusClientstatus)
      {
          RegisterWritestatus=modbusTCPClient.holdingRegisterWrite(SLAVEDEVICEID, modbusdemo_module_holdregisteraddr, modbusdemo_module_holdregistervalue);
          reload_dog();
          delay(500);

      }
    }

    
 
}  //xTask_eg118_ModbusTCP_demo_func


#include <ArduinoModbus.h>



#define RX1PIN GPIO_NUM_33
#define TX1PIN GPIO_NUM_32

void xTask_modbus_demo_rtu_func(void *xTask1) 

{
  Serial1.begin(115200, SERIAL_8N1, RX1PIN, TX1PIN);
  reload_dog();
  //Serial.println("line 1604  [ModbusRTUClient.begin]");
  if (!ModbusRTUClient.begin(115200)) 
  {
     
    while (1) 
    {
      Serial.println("[setup]Failed to start Modbus RTU Client!");
    }
  }
  reload_dog();

  while (1) {

    ModbusRTUClient.holdingRegisterWrite(SLAVEDEVICEID, modbusdemo_module_holdregisteraddr , modbusdemo_module_holdregistervalue);
   // ModbusRTUClient.holdingRegisterWrite(SLAVEDEVICEID, 4 , 34);
     Serial.println("[xTask_modbus_demo_rtu_func]->loop");
    delay(500);
  }
}  //xTask_modbus_demo_rtu_func

void modbus_demo_tcp_task_start(void)
{
  if (DEVICE_MODE_MODBUS_TCP == device_mode) 
  {
    
    xTaskCreate(
      xTask_modbus_demo_tcp_func,   /* Task function. */
      "xTask_modbus_demo_tcp_func", /* String with name of task. */
      4096,                /* Stack size in bytes. */
      NULL,                /* Parameter passed as input of the task */
      5,                   /* Priority of the task.(configMAX_PRIORITIES - 1 being the highest, and 0 being the lowest.) */
      NULL);
  }

}


void modbus_demo_rtu_task_start(void)
{
  if (DEVICE_MODE_MODBUS_RTU == device_mode) 
  {
    
    xTaskCreate(
      xTask_modbus_demo_rtu_func,   /* Task function. */
      "xTask_modbus_demo_rtu_func", /* String with name of task. */
      4096,                /* Stack size in bytes. */
      NULL,                /* Parameter passed as input of the task */
      5,                   /* Priority of the task.(configMAX_PRIORITIES - 1 being the highest, and 0 being the lowest.) */
      NULL);
  }
}
int pctool_modbus_demo_class::rtu_start(void)
{
    int rc=0;
   device_mode = eg118_system_parameter_modbus_demo_module.GetdeviceMode();
    modbus_demo_rtu_task_start();
    return rc;
}

int pctool_modbus_demo_class::tcp_start(void)
{
    int rc=0;
   device_mode = eg118_system_parameter_modbus_demo_module.GetdeviceMode();
    modbus_demo_tcp_task_start();
    return rc;
}

int pctool_modbus_demo_class::setholdregisteraddress(int holdregisteraddress)
{
    int rc=0;
    modbusdemo_module_holdregisteraddr=holdregisteraddress;
    
    return rc;


}
int pctool_modbus_demo_class::setholdregistervalue(int holdregistervalue)
{
    int rc=0;
    modbusdemo_module_holdregistervalue=holdregistervalue;
    return rc;


}

int pctool_modbus_demo_class::getSetupAddress(void)
{
    int SetupholdregisterAddress=SLAVEDEVICEADDRESS;
    //modbusdemo_module_holdregistervalue=holdregistervalue;
    return SetupholdregisterAddress;
}

int pctool_modbus_demo_class::getSetupSlaveid(void)
{
    int SetupSlaveid=SLAVEDEVICEID;
    //modbusdemo_module_holdregistervalue=holdregistervalue;
    return SetupSlaveid;
}









