/***************************************************************************************************
                                    ExploreEmbedded Copyright Notice    
****************************************************************************************************
 * File:   HUAWEI_IOT.h
 * Version: 1.0
 * Author: ExploreEmbedded
 * Website: http://www.exploreembedded.com/wiki
 * Description: ESP32  Arduino library for AWS IOT.
 
This code has been developed and tested on ExploreEmbedded boards.  
We strongly believe that the library works on any of development boards for respective controllers. 
Check this link http://www.exploreembedded.com/wiki for awesome tutorials on 8051,PIC,AVR,ARM,Robotics,RTOS,IOT.
ExploreEmbedded invests substantial time and effort developing open source HW and SW tools, to support consider buying the ExploreEmbedded boards.
 
The ExploreEmbedded libraries and examples are licensed under the terms of the new-bsd license(two-clause bsd license).
See also: http://www.opensource.org/licenses/bsd-license.php

EXPLOREEMBEDDED DISCLAIMS ANY KIND OF HARDWARE FAILURE RESULTING OUT OF USAGE OF LIBRARIES, DIRECTLY OR
INDIRECTLY. FILES MAY BE SUBJECT TO CHANGE WITHOUT PRIOR NOTICE. THE REVISION HISTORY CONTAINS THE INFORMATION 
RELATED TO UPDATES.
 

Permission to use, copy, modify, and distribute this software and its documentation for any purpose
and without fee is hereby granted, provided that this copyright notices appear in all copies 
and that both those copyright notices and this permission notice appear in supporting documentation.
**************************************************************************************************/
 
 
#ifndef _SYSTEM_PARAMETER_H_
#define _SYSTEM_PARAMETER_H_


class system_parameter{
    
    private:
    
    public:

    int set_74HC595_chipvalue(unsigned char outstatus_data);
    unsigned char get_74HC595CHIP_VALUE(void);
    int set_current_initialadc(void);
    int set_bigcurrent_adc(int adc_value);
    int get_bigcurrent_adc(void);
    int set_smallcurrent_adc(int adc_value);
    int get_smallcurrent_adc(void);
    int set_sn_length(unsigned char length);
    int get_sn_length(void);
    int set_M100SNr_string(char arr[], int length);
    int getm100sn_string(char arr[], unsigned char length);
    int set_basemac_length(unsigned char length);
    unsigned char get_basemac_length(void);

    int set_tcpserver_ip_length(unsigned char length);

     int set_modbustcpserver_ip_length(unsigned char length);
    int set_tcpserver_port_length(unsigned char length);
    int set_tcpserver_ip_string(char arr[], int length);
    int set_modbustcpserver_ip_string(char arr[], int length);
    int set_tcpserver_port__string(char arr[], int length);

    int get_tcpserver_ip_length(void);
    int get_modbusserver_ip_length(void);
    int get_modbusserver_ip_string(char arr[], unsigned char length);
    int get_tcpserver_ip_string(char arr[], unsigned char length);
    int get_tcpserver_port_length(void);
    int get_tcpserver_port__string(char arr[], unsigned char length);
    
    int set_mqtt_server_ip_length(unsigned char length);
    int set_mqttserver_ip_string(char arr[], int length);
    int set_mqtt_server_user_length(unsigned char length);
    int set_mqttserver_user_string(char arr[], int length);
    int set_mqtt_server_pass_length(unsigned char length);
    int set_mqtt_pass_string(char arr[], int length);
    
    int get_mqtt_server_ip_length(void);
    int get_mqtt_SERVER_string(char arr[],unsigned char length);
    int get_mqtt_server_user_length(void);
    int get_mqtt_user_string(char arr[],unsigned char length);
    int get_mqtt_server_pass_length(void);
    int get_mqtt_pass_string(char arr[],unsigned char length);

    int set_M100basemac_string(char arr[], int length);
    int get_basemac_string(char arr[],unsigned char length);
    int set_m100muver_length(unsigned char length);
    unsigned char getM100_MUVER_length(void);

    int set_m100muver_string(char arr[], int length);
    int getM100_MUVER_string(char arr[], unsigned char length);

    int set_wifi_status(unsigned char wifimode);
    int get_wifi_status(void);
    int Getpoweron_wifi_status(void);

    int setpoweronwifiSSIDlength(unsigned char SSIDlength);
    int setpoweronwifiSSIDstr(char arr[],int length);
    int set_wifissid_length(unsigned char length);
    int getwifiSSIDlength(void);
    int getpoweronwifiSSID_string(char arr[],unsigned char length);
    int setwifi_password_length(unsigned char length);
    int setwifi_password_str(char arr[], int length);
    int getwifi_password_length(void);
    int getwifi_password__string(char arr[],unsigned char length);
   
    int set_deviceMode_AT_MODE(void);
    int set_deviceMode_TCP_DTU_ONLY(void);
    int set_deviceMode_MQTT_DTU_ONLY(void);
    int set_deviceMode_HUAWEI_IOT_NOSSL(void);
    int set_deviceMode_AWS_IOT(void);
    void set_deviceMode_MODBUS_RTU(void);
    void set_deviceMode_MODBUS_TCP(void);
    int set_deviceMode_MODBUSCONTROLIO_ONLY(void);
    int set_deviceMode_TH485PE_DEMO(void);

//     int set_deviceMode_USERIO_AO_DEMO(void); 
//    int set_deviceMode_USRIO_DEMO(void); 
    int GetdeviceMode(void);

    int set_CONNECT_TO_NET_WITH_WIFIMODE(void);
     int set_CONNECT_TO_NET_WITH_ETHERNETMODE(void);
     int GetconnectMode(void);

     int parameter_refreshEEPROMRAM(void);
     int parameter_config_start(void);

    int set_slot1_usrio_type(unsigned short  type); 
   unsigned short get_slot1_usrio_type(void); 

    int set_slot2_usrio_type(unsigned short  type); 
   unsigned short get_slot2_usrio_type(void); 
    int set_slot3_usrio_type(unsigned short  type); 
   unsigned short get_slot3_usrio_type(void); 
};


#endif

